The viewer and designer can be combined into one edit-and-preview flow, switching between them with a flag.

In Angular.
@Component({
    imports: [Viewer, Designer],
    template: `
    @if (isViewer) {
        <sti-viewer [report]="report" [options]="viewerOptions"
            (onDesignReport)="onDesignReport($event)" (onOpenedReport)="onOpenedReport($event)"></sti-viewer>
    } @else {
        <sti-designer [(report)]="report" [options]="designerOptions"
            (onExit)="onExitDesigner()" (onAssignedReport)="onAssignedReport($event)"></sti-designer>
    }`
})
export class Example {
    report: Stimulsoft.Report.StiReport;
    viewerOptions: Stimulsoft.Viewer.StiViewerOptions;
    designerOptions: Stimulsoft.Designer.StiDesignerOptions;
    isViewer = true;

    onDesignReport(a) { this.isViewer = false; }
    onOpenedReport(a) { this.report = a.report; }
    async onExitDesigner() { await this.report.renderAsync2(); this.isViewer = true; }
    onAssignedReport(a) { this.report = a.report; }

    constructor() {
        this.report = new Stimulsoft.Report.StiReport();
        this.report.loadFile("Dashboards/Dashboard.mrt");

        this.viewerOptions = new Stimulsoft.Viewer.StiViewerOptions();
        this.viewerOptions.toolbar.showDesignButton = true;

        this.designerOptions = new Stimulsoft.Designer.StiDesignerOptions();
        this.designerOptions.toolbar.showFileMenuExit = true;
    }
}

How it works. A single flag chooses which component renders, so users move from dashboard preview to editing and back within one screen.

By using this website, you agree to the use of cookies for analytics and personalized content. Cookies store useful information on your computer to help us improve efficiency and usability. For more information, please read the privacy policy and cookie policy.

Working with onDesign and onExit Events
Our sample projects and report templates can help you learn the basics of working with our products.The viewer and designer can be combined into one edit-and-preview flow, switching between them with a flag.
In Vue.
How it works. A single flag chooses which component renders, so users move from dashboard preview to editing and back within one screen.
In Vue.
<script setup lang="ts">
import { ref } from "vue";
import { Viewer, Stimulsoft } from "stimulsoft-dashboards-js-vuejs/viewer";
import { Designer } from "stimulsoft-dashboards-js-vuejs/designer";
const isViewer = ref(true);
var report = new Stimulsoft.Report.StiReport();
report.loadFile("Dashboards/Dashboard.mrt");
function onDesignReport(a) { isViewer.value = false; }
function onOpenedReport(a) { report = a.report; }
async function onExitDesigner() { await report.renderAsync2(); isViewer.value = true; }
function onAssignedReport(a) { report = a.report; }
</script>
<template>
<Viewer v-if="isViewer" :report="report" @design-report="onDesignReport" @opened-report="onOpenedReport" />
<Designer v-else :report="report" @exit="onExitDesigner" @assigned-report="onAssignedReport" />
</template>onDesignReport— the viewer's Design button; switch the flag to show the designer.onExit— the designer's Exit; re-render the dashboard and switch back to the viewer.
How it works. A single flag chooses which component renders, so users move from dashboard preview to editing and back within one screen.